/* This file is part of toroidtoe, a web server implementing a game of
 * five-in-a-row on a grid warped onto a surface of a torus.  This
 * program is intended as a basis for student exercises on courses at
 * Helsinki University of Technology.  This source code is distributed
 * under the GPL.
 *
 * Author: Kenneth Oksanen <cessu@iki.fi>
 */


/* Networking code, a very conventional UNIX listening socket creation
   and a select-loop. */


#ifndef INCL_NET
#define INCL_NET  1


/* The type of the callback function that the network event loop calls
   for incoming messages.  fd is the file descriptor from which the
   message was received, the next arguments give the number of bytes
   and a pointer to the buffer of bytes received.  The bytes buffer is
   stack-allocated and therefore does not survive past the call to the
   callback.  A terminating nil character is appended to the end of
   the data for the convenience of parsing textual messages.  A
   callback with 0 n_bytes and NULL bytes is called for all closing
   connections in case the callee wishes to perform some cleanups.  If
   the callback returns zero, the connection is closed. */

typedef int (*callback_t)(int fd, int n_bytes, char *bytes);

/* The network event loop which calls `cb' for all incoming messages.
   Does not return except in cases of error. */

void net_event_loop(callback_t cb);


#endif
